diff --git a/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
index 47b143630..1c45f2f8a 100644
--- a/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingCherry.java
@@ -8,13 +8,13 @@ import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeCherry;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreeFancy;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            BlockFlower, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class SaplingCherryBlock extends SaplingBaseBlock
+public class BlockSaplingCherry extends BlockSaplingBase
 {
 
-	public SaplingCherryBlock(String key, String namespaceId, int id)
+	public BlockSaplingCherry(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
index 64fa1f8e9..bb98975f9 100644
--- a/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingEucalyptus.java
@@ -7,13 +7,13 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            BlockFlower, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class SaplingEucalyptusBlock extends SaplingBaseBlock
+public class BlockSaplingEucalyptus extends BlockSaplingBase
 {
 
-	public SaplingEucalyptusBlock(String key, String namespaceId, int id)
+	public BlockSaplingEucalyptus(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingOakBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
similarity index 84%
rename from src/main/java/net/minecraft/core/block/SaplingOakBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingOak.java
index 4a1365258..e359156e6 100644
--- a/src/main/java/net/minecraft/core/block/SaplingOakBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingOak.java
@@ -8,13 +8,13 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            BlockFlower, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class SaplingOakBlock extends SaplingBaseBlock
+public class BlockSaplingOak extends BlockSaplingBase
 {
 
-	public SaplingOakBlock(String key, String namespaceId, int id)
+	public BlockSaplingOak(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingPalmBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/SaplingPalmBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
index d5eee8e85..2ad4876a4 100644
--- a/src/main/java/net/minecraft/core/block/SaplingPalmBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingPalm.java
@@ -5,9 +5,9 @@ import java.util.Random;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.generate.feature.tree.WorldFeatureTreePalm;
 
-public class SaplingPalmBlock extends SaplingBaseBlock {
+public class BlockSaplingPalm extends BlockSaplingBase {
 
-	public SaplingPalmBlock(String key, String namespaceId, int id) {
+	public BlockSaplingPalm(String key, String namespaceId, int id) {
 		super(key, namespaceId, id);
 		
 		this.canGrowOnSand = true;
diff --git a/src/main/java/net/minecraft/core/block/SaplingPineBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingPine.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/SaplingPineBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingPine.java
index 901b049c6..3e66bae0e 100644
--- a/src/main/java/net/minecraft/core/block/SaplingPineBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingPine.java
@@ -8,13 +8,13 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            BlockFlower, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class SaplingPineBlock extends SaplingBaseBlock
+public class BlockSaplingPine extends BlockSaplingBase
 {
 
-	public SaplingPineBlock(String key, String namespaceId, int id)
+	public BlockSaplingPine(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
index f378b2f96..0e553cd7e 100644
--- a/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingRetro.java
@@ -8,13 +8,13 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            BlockFlower, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class SaplingRetroBlock extends SaplingBaseBlock
+public class BlockSaplingRetro extends BlockSaplingBase
 {
 
-	public SaplingRetroBlock(String key, String namespaceId, int id)
+	public BlockSaplingRetro(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
index b77d4a015..defa974ab 100644
--- a/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingShrub.java
@@ -7,13 +7,13 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, World, WorldGenTaiga2, WorldGenForest,
+//            BlockFlower, World, WorldGenTaiga2, WorldGenForest,
 //            WorldGenTrees, WorldGenBigTree, WorldGenerator
 
-public class SaplingShrubBlock extends SaplingBaseBlock
+public class BlockSaplingShrub extends BlockSaplingBase
 {
 
-	public SaplingShrubBlock(String key, String namespaceId, int id)
+	public BlockSaplingShrub(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingThornBlock.java b/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
similarity index 85%
rename from src/main/java/net/minecraft/core/block/SaplingThornBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
index 3eb007099..25a8bdb33 100644
--- a/src/main/java/net/minecraft/core/block/SaplingThornBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSaplingThorn.java
@@ -6,10 +6,10 @@ import net.minecraft.core.world.generate.feature.WorldFeature;
 
 import java.util.Random;
 
-public class SaplingThornBlock extends SaplingBaseBlock
+public class BlockSaplingThorn extends BlockSaplingBase
 {
 
-    public SaplingThornBlock(String key, String namespaceId, int id)
+    public BlockSaplingThorn(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
     }
diff --git a/src/main/java/net/minecraft/core/block/SeatBlock.java b/src/main/java/net/minecraft/core/block/BlockSeat.java
similarity index 75%
rename from src/main/java/net/minecraft/core/block/SeatBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSeat.java
index 52dabc50c..268be8395 100644
--- a/src/main/java/net/minecraft/core/block/SeatBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSeat.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.SeatBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntitySeat;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -10,10 +10,10 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class SeatBlock
-    extends EntityBlock
+public class BlockSeat
+    extends BlockTileEntity
 {
-    public SeatBlock(String key, String namespaceId, int id) {
+    public BlockSeat(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.wood);
         
         setBlockBounds(0f, 0f, 0f, 1f, 9f / 16f, 1f);
@@ -25,7 +25,7 @@ public class SeatBlock
             return false;
         }
         if (!world.isClientSide) {
-            SeatBlockEntity tileEntity = (SeatBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntitySeat tileEntity = (TileEntitySeat) world.getBlockEntity(x, y, z);
             if (tileEntity.getPassenger() == null) {
                 player.startRiding(tileEntity);
             }
@@ -37,7 +37,7 @@ public class SeatBlock
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data) {
         if (!world.isClientSide) {
-            SeatBlockEntity tileEntity = (SeatBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntitySeat tileEntity = (TileEntitySeat) world.getBlockEntity(x, y, z);
             if (tileEntity != null && tileEntity.getPassenger() != null) {
                 tileEntity.ejectRider();
             }
@@ -56,12 +56,12 @@ public class SeatBlock
     }
     
     @Override
-    protected BlockEntity getNewBlockEntity() {
-        return new SeatBlockEntity(this);
+    protected TileEntity getNewBlockEntity() {
+        return new TileEntitySeat(this);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
         if (dropCause != EnumDropCause.IMPROPER_TOOL)
         {
             return new ItemStack[] { new ItemStack(Items.SEAT) };
diff --git a/src/main/java/net/minecraft/core/block/SignBlock.java b/src/main/java/net/minecraft/core/block/BlockSign.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/SignBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSign.java
index e95cdad70..e703f2a4c 100644
--- a/src/main/java/net/minecraft/core/block/SignBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSign.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.SignBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
@@ -13,11 +13,11 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.WorldSource;
 
-public class SignBlock extends EntityBlock
+public class BlockSign extends BlockTileEntity
 {
     private final boolean isFreeStanding;
 
-	public SignBlock(String key, String namespaceId, int id, boolean isFreeStanding)
+	public BlockSign(String key, String namespaceId, int id, boolean isFreeStanding)
     {
         super(key, namespaceId, id, Material.wood);
         this.isFreeStanding = isFreeStanding;
@@ -107,9 +107,9 @@ public class SignBlock extends EntityBlock
     }
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
-        return new SignBlockEntity();
+        return new TileEntitySign();
     }
 
     @Override
@@ -151,13 +151,13 @@ public class SignBlock extends EntityBlock
         super.onNeighborBlockChange(world, x, y, z, blockId);
     }
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         return new ItemStack[] { new ItemStack(Items.SIGN) };
     }
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
-        SignBlockEntity signEntity = (SignBlockEntity)world.getBlockEntity(x, y, z);
+        TileEntitySign signEntity = (TileEntitySign)world.getBlockEntity(x, y, z);
         if (signEntity != null && player != null) {
             if (player.getHeldItem() != null && player.getHeldItem().itemID == Items.DUST_GLOWSTONE.id && !signEntity.isGlowing()) {
                 signEntity.setGlowing(true);
diff --git a/src/main/java/net/minecraft/core/block/SlabBlock.java b/src/main/java/net/minecraft/core/block/BlockSlab.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/SlabBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSlab.java
index 86513126a..2c410d618 100644
--- a/src/main/java/net/minecraft/core/block/SlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSlab.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.block.SlabBlockItem;
+import net.minecraft.core.item.block.ItemBlockSlab;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
@@ -21,16 +21,16 @@ import java.util.Random;
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, IBlockAccess
 
-public class SlabBlock extends Block
+public class BlockSlab extends Block
 {
 
-    public SlabBlock(Block modelBlock, String namespaceId, int id)
+    public BlockSlab(Block modelBlock, String namespaceId, int id)
     {
         this(modelBlock, namespaceId, id, 0);
-        setBlockItem(() -> new SlabBlockItem(this));
+        setBlockItem(() -> new ItemBlockSlab(this));
     }
     
-    public SlabBlock(Block modelBlock, String namespaceId, int id, int modelBlockMetadata)
+    public BlockSlab(Block modelBlock, String namespaceId, int id, int modelBlockMetadata)
     {
     	super("slab." + modelBlock.key.substring(5), namespaceId, id, modelBlock.blockMaterial);
         this.modelBlock = modelBlock;
@@ -85,9 +85,9 @@ public class SlabBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
     {
-        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, modelBlockMetadata, blockEntity);
+        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, modelBlockMetadata, tileEntity);
 
         if (result != null)
         {
@@ -107,9 +107,9 @@ public class SlabBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
-        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, modelBlockMetadata, blockEntity);
+        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, modelBlockMetadata, tileEntity);
 
         if (result != null)
         {
diff --git a/src/main/java/net/minecraft/core/block/PaintableSlabBlock.java b/src/main/java/net/minecraft/core/block/BlockSlabPaintable.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/PaintableSlabBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSlabPaintable.java
index 96b12d38b..2952fb178 100644
--- a/src/main/java/net/minecraft/core/block/PaintableSlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSlabPaintable.java
@@ -1,17 +1,17 @@
-package net.minecraft.core.block;
-
-import net.minecraft.core.util.helper.DyeColor;
-import net.minecraft.core.world.World;
-
-public class PaintableSlabBlock extends SlabBlock implements IPaintable {
-    public PaintableSlabBlock(Block modelBlock, String namespaceId, int id) {
-        super(modelBlock, namespaceId, id);
-    }
-
-    @Override
-    public void setColor(World world, int x, int y, int z, DyeColor color) {
-        final int meta = world.getBlockMetadata(x, y, z);
-        world.setBlockAndMetadata(x, y, z, Blocks.SLAB_PLANKS_PAINTED.id, meta);
-        ((IPaintable) Blocks.SLAB_PLANKS_PAINTED).setColor(world, x, y, z, color);
-    }
-}
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class BlockSlabPaintable extends BlockSlab implements IPaintable {
+    public BlockSlabPaintable(Block modelBlock, String namespaceId, int id) {
+        super(modelBlock, namespaceId, id);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadata(x, y, z, Blocks.SLAB_PLANKS_PAINTED.id, meta);
+        ((IPaintable) Blocks.SLAB_PLANKS_PAINTED).setColor(world, x, y, z, color);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java b/src/main/java/net/minecraft/core/block/BlockSlabPainted.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSlabPainted.java
index 3eb3e0365..1e00cbd03 100644
--- a/src/main/java/net/minecraft/core/block/PaintedSlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSlabPainted.java
@@ -10,9 +10,9 @@ import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class PaintedSlabBlock extends SlabBlock implements IPainted
+public class BlockSlabPainted extends BlockSlab implements IPainted
 {
-	public PaintedSlabBlock(Block modelBlock, String namespaceId, int id)
+	public BlockSlabPainted(Block modelBlock, String namespaceId, int id)
 	{
 		super(modelBlock, namespaceId, id);
 	}
diff --git a/src/main/java/net/minecraft/core/block/SlipperyBlock.java b/src/main/java/net/minecraft/core/block/BlockSlippery.java
similarity index 64%
rename from src/main/java/net/minecraft/core/block/SlipperyBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSlippery.java
index 804b2880b..c604966ea 100644
--- a/src/main/java/net/minecraft/core/block/SlipperyBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSlippery.java
@@ -2,9 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public class SlipperyBlock extends Block {
+public class BlockSlippery extends Block {
 
-    public SlipperyBlock(String key, String namespaceId, int id, Material material) {
+    public BlockSlippery(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
         friction = 0.98F;
     }
diff --git a/src/main/java/net/minecraft/core/block/SnowBlock.java b/src/main/java/net/minecraft/core/block/BlockSnow.java
similarity index 87%
rename from src/main/java/net/minecraft/core/block/SnowBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSnow.java
index 9569acc0b..12f55c4cc 100644
--- a/src/main/java/net/minecraft/core/block/SnowBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSnow.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
@@ -14,10 +14,10 @@ import java.util.Random;
 //            Block, Material, Item, EnumSkyBlock, 
 //            World
 
-public class SnowBlock extends Block
+public class BlockSnow extends Block
 {
 
-	public SnowBlock(String key, String namespaceId, int id)
+	public BlockSnow(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.snow);
         setTicking(true);
@@ -39,7 +39,7 @@ public class SnowBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/SoulSandBlock.java b/src/main/java/net/minecraft/core/block/BlockSoulSand.java
similarity index 88%
rename from src/main/java/net/minecraft/core/block/SoulSandBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSoulSand.java
index 96596648c..4772523d2 100644
--- a/src/main/java/net/minecraft/core/block/SoulSandBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSoulSand.java
@@ -11,10 +11,10 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class SoulSandBlock extends Block
+public class BlockSoulSand extends Block
 {
 
-    public SoulSandBlock(String key, String namespaceId, int id)
+    public BlockSoulSand(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id, Material.soulsand);
     }
diff --git a/src/main/java/net/minecraft/core/block/SpikesBlock.java b/src/main/java/net/minecraft/core/block/BlockSpikes.java
similarity index 92%
rename from src/main/java/net/minecraft/core/block/SpikesBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSpikes.java
index e703356fa..51c8ca404 100644
--- a/src/main/java/net/minecraft/core/block/SpikesBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSpikes.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -16,11 +16,11 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.NotNull;
 
-public class SpikesBlock extends Block
+public class BlockSpikes extends Block
 {
     public static final int MASK_POWERED = 0b0000_0001;
 
-    public SpikesBlock(String key, String namespaceId, int id, Material mat)
+    public BlockSpikes(String key, String namespaceId, int id, Material mat)
     {
         super(key, namespaceId, id, mat);
     }
@@ -38,7 +38,7 @@ public class SpikesBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         return new ItemStack[] { new ItemStack(Blocks.SPIKES) };
     }
@@ -102,7 +102,7 @@ public class SpikesBlock extends Block
 
     @Override
     public boolean collidesWithEntity(Entity entity, World world, int x, int y, int z) {
-        return !(entity instanceof ItemEntity);
+        return !(entity instanceof EntityItem);
     }
     
     public static boolean isSpikesUp(int i)
diff --git a/src/main/java/net/minecraft/core/block/SpinifexBlock.java b/src/main/java/net/minecraft/core/block/BlockSpinifex.java
similarity index 73%
rename from src/main/java/net/minecraft/core/block/SpinifexBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSpinifex.java
index d83e70500..7e428a88a 100644
--- a/src/main/java/net/minecraft/core/block/SpinifexBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSpinifex.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            FlowerBlock, Block
+//            BlockFlower, Block
 
-public class SpinifexBlock extends FlowerBlock
+public class BlockSpinifex extends BlockFlower
 {
 
-	public SpinifexBlock(String key, String namespaceId, int id)
+	public BlockSpinifex(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
         float f = 0.4F;
@@ -19,7 +19,7 @@ public class SpinifexBlock extends FlowerBlock
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/SpongeBlock.java b/src/main/java/net/minecraft/core/block/BlockSponge.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/SpongeBlock.java
rename to src/main/java/net/minecraft/core/block/BlockSponge.java
index fd6f03993..a016fbc3b 100644
--- a/src/main/java/net/minecraft/core/block/SpongeBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockSponge.java
@@ -13,10 +13,10 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class SpongeBlock extends Block
+public class BlockSponge extends Block
 {
     final boolean isWet;
-	public SpongeBlock(String key, String namespaceId, int id, boolean isWet)
+	public BlockSponge(String key, String namespaceId, int id, boolean isWet)
     {
         super(key, namespaceId, id, Material.sponge);
         this.isWet = isWet;
diff --git a/src/main/java/net/minecraft/core/block/StairsBlock.java b/src/main/java/net/minecraft/core/block/BlockStairs.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/StairsBlock.java
rename to src/main/java/net/minecraft/core/block/BlockStairs.java
index eb2221b80..55cec6b5f 100644
--- a/src/main/java/net/minecraft/core/block/StairsBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockStairs.java
@@ -3,7 +3,7 @@ package net.minecraft.core.block;
 import java.util.ArrayList;
 import java.util.Random;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -23,7 +23,7 @@ import org.jetbrains.annotations.NotNull;
 //            IBlockAccess, AxisAlignedBB, Player, Entity,
 //            Vec3D
 
-public class StairsBlock extends Block
+public class BlockStairs extends Block
 {
 //    private static final Map<Integer, BoundingVolume> selectionVolumes = new HashMap<>();
 //
@@ -86,7 +86,7 @@ public class StairsBlock extends Block
 //        selectionVolumes.put(0b1011, vol);
 //    }
 
-	public StairsBlock(Block block, String namespaceId, int id)
+	public BlockStairs(Block block, String namespaceId, int id)
     {
         super("stairs." + block.key.substring(5), namespaceId, id, block.blockMaterial);
         modelBlock = block;
@@ -163,9 +163,9 @@ public class StairsBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
     {
-        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, 0, blockEntity);
+        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, x, y, z, 0, tileEntity);
 
         if (result != null)
         {
@@ -183,9 +183,9 @@ public class StairsBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
-        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, 0, blockEntity);
+        ItemStack[] result = modelBlock.getBreakResult(world, dropCause, 0, tileEntity);
 
         if (result != null)
         {
